nRF51 SDK: Functions

| nRF51 SDK

- Home
- Related Pages
- API Reference
- Data Structures

All Data Structures Functions Variables Typedefs Enumerations Enumerator Groups Pages
Functions
Functions
Generic Attribute Profile (GATT) Client

## Functions

uint32_t | sd_ble_gattc_primary_services_discover (uint16_t conn_handle, uint16_t start_handle, ble_uuid_t const *p_srvc_uuid)
| Initiate or continue a GATT Primary Service Discovery procedure. More...
uint32_t | sd_ble_gattc_relationships_discover (uint16_t conn_handle, ble_gattc_handle_range_t const *p_handle_range)
| Initiate or continue a GATT Relationship Discovery procedure. More...
uint32_t | sd_ble_gattc_characteristics_discover (uint16_t conn_handle, ble_gattc_handle_range_t const *p_handle_range)
| Initiate or continue a GATT Characteristic Discovery procedure. More...
uint32_t | sd_ble_gattc_descriptors_discover (uint16_t conn_handle, ble_gattc_handle_range_t const *p_handle_range)
| Initiate or continue a GATT Characteristic Descriptor Discovery procedure. More...
uint32_t | sd_ble_gattc_char_value_by_uuid_read (uint16_t conn_handle, ble_uuid_t const *p_uuid, ble_gattc_handle_range_t const *p_handle_range)
| Initiate or continue a GATT Read using Characteristic UUID procedure. More...
uint32_t | sd_ble_gattc_read (uint16_t conn_handle, uint16_t handle, uint16_t offset)
| Initiate or continue a GATT Read (Long) Characteristic or Descriptor procedure. More...
uint32_t | sd_ble_gattc_char_values_read (uint16_t conn_handle, uint16_t const *p_handles, uint16_t handle_count)
| Initiate a GATT Read Multiple Characteristic Values procedure. More...
uint32_t | sd_ble_gattc_write (uint16_t conn_handle, ble_gattc_write_params_t const *p_write_params)
| Perform a Write (Characteristic Value or Descriptor, with or without response, signed or not, long or reliable) procedure. More...
uint32_t | sd_ble_gattc_hv_confirm (uint16_t conn_handle, uint16_t handle)
| Send a Handle Value Confirmation to the GATT Server. More...

## Detailed Description

## Function Documentation

uint32_t sd_ble_gattc_char_value_by_uuid_read | ( | uint16_t | conn_handle,
|  | ble_uuid_t const * | p_uuid,
|  | ble_gattc_handle_range_t const * | p_handle_range
| ) |  |

Initiate or continue a GATT Read using Characteristic UUID procedure.

This function initiates the Read using Characteristic UUID procedure. If the last Characteristic has not been reached, this must be called again with an updated handle range to continue the discovery.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_uuid | Pointer to a Characteristic value UUID to read.
  [in] | p_handle_range | A pointer to the range of handles to perform this procedure on.

Return values

  NRF_SUCCESS | Successfully started or resumed the Read using Characteristic UUID procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_char_values_read | ( | uint16_t | conn_handle,
|  | uint16_t const * | p_handles,
|  | uint16_t | handle_count
| ) |  |

Initiate a GATT Read Multiple Characteristic Values procedure.

This function initiates a GATT Read Multiple Characteristic Values procedure.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_handles | A pointer to the handle(s) of the attribute(s) to be read.
  [in] | handle_count | The number of handles in p_handles.

Return values

  NRF_SUCCESS | Successfully started the Read Multiple Characteristic Values procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_characteristics_discover | ( | uint16_t | conn_handle,
|  | ble_gattc_handle_range_t const * | p_handle_range
| ) |  |

Initiate or continue a GATT Characteristic Discovery procedure.

This function initiates a Characteristic discovery procedure. If the last Characteristic has not been reached, this must be called again with an updated handle range to continue the discovery.

Note
  If any of the discovered characteristics have 128-bit UUIDs which are not present in the table provided to ble_vs_uuids_assign, a UUID structure with type BLE_UUID_TYPE_UNKNOWN will be received in the corresponding event.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_handle_range | A pointer to the range of handles of the Service to perform this procedure on.

Return values

  NRF_SUCCESS | Successfully started or resumed the Characteristic Discovery procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_descriptors_discover | ( | uint16_t | conn_handle,
|  | ble_gattc_handle_range_t const * | p_handle_range
| ) |  |

Initiate or continue a GATT Characteristic Descriptor Discovery procedure.

This function initiates the Characteristic Descriptor discovery procedure. If the last Descriptor has not been reached, this must be called again with an updated handle range to continue the discovery.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_handle_range | A pointer to the range of handles of the Characteristic to perform this procedure on.

Return values

  NRF_SUCCESS | Successfully started or resumed the Descriptor Discovery procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_hv_confirm | ( | uint16_t | conn_handle,
|  | uint16_t | handle
| ) |  |

Send a Handle Value Confirmation to the GATT Server.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | handle | The handle of the attribute in the indication.

Return values

  NRF_SUCCESS | Successfully queued the Handle Value Confirmation for transmission.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_STATE | No Indication pending to be confirmed.
  BLE_ERROR_INVALID_ATTR_HANDLE | Invalid attribute handle.

uint32_t sd_ble_gattc_primary_services_discover | ( | uint16_t | conn_handle,
|  | uint16_t | start_handle,
|  | ble_uuid_t const * | p_srvc_uuid
| ) |  |

Initiate or continue a GATT Primary Service Discovery procedure.

This function initiates a Primary Service discovery, starting from the supplied handle. If the last service has not been reached, this must be called again with an updated start handle value to continue the search.

Note
  If any of the discovered services have 128-bit UUIDs which are not present in the table provided to ble_vs_uuids_assign, a UUID structure with type BLE_UUID_TYPE_UNKNOWN will be received in the corresponding event.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | start_handle | Handle to start searching from.
  [in] | p_srvc_uuid | Pointer to the service UUID to be found. If it is NULL, all primary services will be returned.

Return values

  NRF_SUCCESS | Successfully started or resumed the Primary Service Discovery procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_PARAM | Invalid parameter(s) supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_read | ( | uint16_t | conn_handle,
|  | uint16_t | handle,
|  | uint16_t | offset
| ) |  |

Initiate or continue a GATT Read (Long) Characteristic or Descriptor procedure.

This function initiates a GATT Read (Long) Characteristic or Descriptor procedure. If the Characteristic or Descriptor to be read is longer than GATT_MTU - 1, this function must be called multiple times with appropriate offset to read the complete value.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | handle | The handle of the attribute to be read.
  [in] | offset | Offset into the attribute value to be read.

Return values

  NRF_SUCCESS | Successfully started or resumed the Read (Long) procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_relationships_discover | ( | uint16_t | conn_handle,
|  | ble_gattc_handle_range_t const * | p_handle_range
| ) |  |

Initiate or continue a GATT Relationship Discovery procedure.

This function initiates the Find Included Services sub-procedure. If the last included service has not been reached, this must be called again with an updated handle range to continue the search.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_handle_range | A pointer to the range of handles of the Service to perform this procedure on.

Return values

  NRF_SUCCESS | Successfully started or resumed the Relationship Discovery procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_INVALID_PARAM | Invalid parameter(s) supplied.
  NRF_ERROR_BUSY | Client procedure already in progress.

uint32_t sd_ble_gattc_write | ( | uint16_t | conn_handle,
|  | ble_gattc_write_params_t const * | p_write_params
| ) |  |

Perform a Write (Characteristic Value or Descriptor, with or without response, signed or not, long or reliable) procedure.

This function can perform all write procedures described in GATT.

Note
  It is important to note that a write without response will consume an application buffer, and will therefore generate a BLE_EVT_TX_COMPLETE event when the packet has been transmitted. A write on the other hand will use the standard client internal buffer and thus will only generate a BLE_GATTC_EVT_WRITE_RSP event as soon as the write response has been received from the peer. Please see the documentation of sd_ble_tx_buffer_count_get for more details.

Parameters

  [in] | conn_handle | The connection handle identifying the connection to perform this procedure on.
  [in] | p_write_params | A pointer to a write parameters structure.

Return values

  NRF_SUCCESS | Successfully started the Write procedure.
  BLE_ERROR_INVALID_CONN_HANDLE | Invalid Connection Handle.
  NRF_ERROR_INVALID_ADDR | Invalid pointer supplied.
  NRF_ERROR_INVALID_PARAM | Invalid parameter(s) supplied.
  NRF_ERROR_DATA_SIZE | Invalid data size(s) supplied.
  NRF_ERROR_BUSY | Procedure already in progress.
  BLE_ERROR_NO_TX_BUFFERS | There are no available buffers left.